"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Period = exports.Period = function () {
    function Period(_ref) {
        var _ref$days = _ref.days,
            days = _ref$days === undefined ? 0 : _ref$days,
            _ref$hours = _ref.hours,
            hours = _ref$hours === undefined ? 0 : _ref$hours,
            _ref$minutes = _ref.minutes,
            minutes = _ref$minutes === undefined ? 0 : _ref$minutes;

        _classCallCheck(this, Period);

        this.days = days;
        this.hours = hours;
        this.minutes = minutes;
    }

    _createClass(Period, [{
        key: "getDays",
        value: function getDays() {
            return this.days;
        }
    }, {
        key: "getHours",
        value: function getHours() {
            return this.hours;
        }
    }, {
        key: "getMinutes",
        value: function getMinutes() {
            return this.minutes;
        }
    }, {
        key: "toStandardMinutes",
        value: function toStandardMinutes() {
            return (this.days * 24 + this.hours) * 60 + this.minutes;
        }
    }, {
        key: "plus",
        value: function plus(_ref2) {
            var days = _ref2.days,
                hours = _ref2.hours,
                minutes = _ref2.minutes;

            return new Period({
                days: this.days + (days || 0),
                hours: this.hours + (hours || 0),
                minutes: this.minutes + (minutes || 0)
            });
        }
    }, {
        key: "plusMinutes",
        value: function plusMinutes(minutesDiff) {
            return this.plus({
                minutes: minutesDiff
            });
        }
    }, {
        key: "normalizedStandard",
        value: function normalizedStandard() {
            var normalizedDays = this.days;
            var normalizedHours = this.hours;
            var normalizedMinutes = this.minutes;

            var extraHours = Math.floor(normalizedMinutes / 60);
            normalizedMinutes -= 60 * extraHours;
            normalizedHours += extraHours;

            var extraDays = Math.floor(normalizedHours / 24);
            normalizedHours -= 24 * extraDays;
            normalizedDays += extraDays;

            return new Period({
                days: normalizedDays,
                hours: normalizedHours,
                minutes: normalizedMinutes
            });
        }
    }]);

    return Period;
}();